# LibBoard::Ellipse Struct Reference

An ellipse. More...

`#include <Shapes.h>`

Inheritance diagram for LibBoard::Ellipse:

List of all members.

## Public Member Functions

| Ellipse (double x, double y, double xRadius, double yRadius, Color penColor, Color fillColor, double lineWidth, const LineStyle lineStyle=SolidStyle, int depth=-1)
const std::string & | name () const
Point | center () const
Ellipse & | rotate (double angle, const Point &center)
Ellipse | rotated (double angle, const Point &center) const
Ellipse & | rotate (double angle)
Ellipse | rotated (double angle) const
Ellipse & | translate (double dx, double dy)
Ellipse | translated (double dx, double dy) const
Shape & | scale (double sx, double sy)
Shape & | scale (double s)
Ellipse | scaled (double sx, double sy) const
Ellipse | scaled (double s) const
void | scaleAll (double s)
void | flushPostscript (std::ostream &stream, const TransformEPS &transform) const
void | flushFIG (std::ostream &stream, const TransformFIG &transform, std::map< Color, int > &colormap) const
void | flushSVG (std::ostream &stream, const TransformSVG &transform) const
Rect | boundingBox () const
Ellipse * | clone () const

## Protected Attributes

Point | _center
double | _xRadius
double | _yRadius
double | _angle
bool | _circle

## Detailed Description

An ellipse.

The ellipse structure.

Examples:

  examples/ellipse.cpp, and examples/example4.cpp.

## Member Function Documentation

Rect LibBoard::Ellipse::boundingBox | ( |  | ) | const`[virtual]`

Returns the bounding box of the figure.

Returns:
  The rectangle of the bounding box.

Implements LibBoard::Shape.

References LibBoard::Point::x, and LibBoard::Point::y.

Point LibBoard::Ellipse::center | ( |  | ) | const`[virtual]`

Returns the gravity center of the shape.

Returns:
  The center of the shape.

Implements LibBoard::Shape.

Reimplemented in LibBoard::Circle.

Referenced by rotate(), and rotated().

Ellipse * LibBoard::Ellipse::clone | ( |  | ) | const`[virtual]`

Return a copy of the shape.

Returns:

Implements LibBoard::Shape.

Reimplemented in LibBoard::Circle.

void LibBoard::Ellipse::flushFIG | ( | std::ostream & | stream,
|  | const TransformFIG & | transform,
|  | std::map< Color, int > & | colormap |
| ) |  |  | const`[virtual]`

Writes the FIG code of the shape in a stream according to a transform.

Parameters:

  | stream | The output stream.
  | transform | A 2D transform to be applied.

Implements LibBoard::Shape.

References LibBoard::Shape::_depth, LibBoard::Shape::_fillColor, LibBoard::Shape::_lineStyle, LibBoard::Shape::_lineWidth, LibBoard::Shape::_penColor, LibBoard::Shape::filled(), LibBoard::Point::x, and LibBoard::Point::y.

void LibBoard::Ellipse::flushPostscript | ( | std::ostream & | stream,
|  | const TransformEPS & | transform |
| ) |  |  | const`[virtual]`

Writes the EPS code of the shape in a stream according to a transform.

Parameters:

  | stream | The output stream.
  | transform | A 2D transform to be applied.

Implements LibBoard::Shape.

References LibBoard::Shape::_fillColor, LibBoard::Shape::_penColor, LibBoard::Shape::filled(), LibBoard::Shape::postscriptProperties(), LibBoard::Point::x, and LibBoard::Point::y.

void LibBoard::Ellipse::flushSVG | ( | std::ostream & | stream,
|  | const TransformSVG & | transform |
| ) |  |  | const`[virtual]`

Writes the SVG code of the shape in a stream according to a transform.

Parameters:

  | stream | The output stream.
  | transform | A 2D transform to be applied.

Implements LibBoard::Shape.

Reimplemented in LibBoard::Circle.

References LibBoard::Shape::svgProperties(), LibBoard::Point::x, and LibBoard::Point::y.

const std::string & LibBoard::Ellipse::name | ( |  | ) | const`[virtual]`

Returns the generic name of the shape (e.g., Circle, Rectangle, etc.)

Returns:

Reimplemented from LibBoard::Shape.

Reimplemented in LibBoard::Circle.

Ellipse & LibBoard::Ellipse::rotate | ( | double | angle | ) | `[virtual]`

Rotate the shape around its center.

Parameters:

  | angle | The rotation angle in radian.

Returns:
  A reference to the shape itself.

Implements LibBoard::Shape.

Reimplemented in LibBoard::Circle.

References center(), and rotate().

Ellipse & LibBoard::Ellipse::rotate | ( | double | angle,
|  | const Point & | center |
| ) |  |  | `[virtual]`

Rotate the shape around a given center of rotation.

Parameters:

  | angle | The rotation angle in radian.
  | center | The center of rotation.

Returns:
  A reference to the shape itself.

Implements LibBoard::Shape.

Reimplemented in LibBoard::Circle.

References LibBoard::Point::rotated(), LibBoard::Point::x, and LibBoard::Point::y.

Referenced by rotate(), and rotated().

Ellipse LibBoard::Ellipse::rotated | ( | double | angle | ) | const

Parameters:

  | angle |

Returns:

Reimplemented in LibBoard::Circle.

References center(), and rotate().

Ellipse LibBoard::Ellipse::rotated | ( | double | angle,
|  | const Point & | center |
| ) |  |  | const

Parameters:

  | angle |
  | center |

Returns:

Reimplemented in LibBoard::Circle.

References rotate().

Shape & LibBoard::Ellipse::scale | ( | double | s | ) | `[virtual]`

Scale the shape along both axis.

Parameters:

  | s | The scale factor along both axis.

Returns:
  The shape itself.

Implements LibBoard::Shape.

Reimplemented in LibBoard::Circle.

References scale().

Shape & LibBoard::Ellipse::scale | ( | double | sx,
|  | double | sy |
| ) |  |  | `[virtual]`

Scale the shape along the x an y axis.

Parameters:

  | sx | The scale factor along the x axis.
  | sy | The scale factor along the y axis.

Returns:
  The shape itself.

Implements LibBoard::Shape.

Reimplemented in LibBoard::Circle.

Referenced by scale().

void LibBoard::Ellipse::scaleAll | ( | double | s | ) | `[virtual]`

Scales all the values (positions, dimensions, etc.) associated with the shape.

Parameters:

  | s | The scaling factor.

Implements LibBoard::Shape.

Reimplemented in LibBoard::Circle.

Ellipse LibBoard::Ellipse::scaled | ( | double | sx,
|  | double | sy |
| ) |  |  | const

Parameters:

  | sx |
  | sy |

Returns:

Reimplemented in LibBoard::Circle.

Ellipse & LibBoard::Ellipse::translate | ( | double | dx,
|  | double | dy |
| ) |  |  | `[virtual]`

Translate the shape by a given offset.

Parameters:

  | dx | The x offset.
  | dy | The y offset.

Returns:
  A reference to the shape itself.

Implements LibBoard::Shape.

Reimplemented in LibBoard::Circle.

Referenced by translated().

Ellipse LibBoard::Ellipse::translated | ( | double | dx,
|  | double | dy |
| ) |  |  | const

Parameters:

  | dx |
  | dy |

Returns:

Reimplemented in LibBoard::Circle.

References translate().

The documentation for this struct was generated from the following files:

- include/board/Shapes.h
- src/Shapes.cpp